module jp.ku6.windows.directx.d3d10misc;

import jp.ku6.windows.win32api.windef;

import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.directx.d3d10;
import jp.ku6.windows.directx.dxgi;

extern (Windows)
{
	interface ID3D10Blob : IUnknown
	{
		LPVOID GetBufferPointer();
		SIZE_T GetBufferSize();
	}
}

enum D3D10_DRIVER_TYPE
{
	D3D10_DRIVER_TYPE_HARDWARE  = 0,
	D3D10_DRIVER_TYPE_REFERENCE = 1,
	D3D10_DRIVER_TYPE_NULL      = 2,
	D3D10_DRIVER_TYPE_SOFTWARE  = 3,
	D3D10_DRIVER_TYPE_WARP      = 5,
}

extern (Windows)
{
	alias HRESULT function(IDXGIAdapter pAdapter, D3D10_DRIVER_TYPE DriverType, HMODULE Software, UINT Flags, UINT SDKVersion, ID3D10Device* ppDevice) D3D10CreateDeviceFunction;
	alias HRESULT function(IDXGIAdapter pAdapter, D3D10_DRIVER_TYPE DriverType, HMODULE Software, UINT Flags, UINT SDKVersion, DXGI_SWAP_CHAIN_DESC* pSwapChainDesc, IDXGISwapChain* ppSwapChain, ID3D10Device* ppDevice) D3D10CreateDeviceAndSwapChainFunction;
	alias HRESULT function(SIZE_T NumBytes, ID3D10Blob* ppBuffer) D3D10CreateBlobFunction;
}


immutable GUID IID_ID3D10Blob  = {0x8ba5fb08, 0x5195, 0x40e2, [0xac, 0x58, 0x0d, 0x98, 0x9c, 0x3a, 0x01, 0x02]};
immutable GUID GUID_DeviceType = {0xd722fb4d, 0x7a68, 0x437a, [0xb2, 0x0c, 0x58, 0x04, 0xee, 0x24, 0x94, 0xa6]};


